//---------------------------------------------------------------------------

#include <fmx.h>
#pragma hdrstop

#include "uMain.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.fmx"
TMain *Main;
//---------------------------------------------------------------------------
__fastcall TMain::TMain(TComponent* Owner)
  : TForm(Owner)
{
  m_Dos = NULL;
}
//---------------------------------------------------------------------------
void __fastcall TMain::FormCreate(TObject *Sender)
{
  TListBox *lb = ListBox1;
  m_ErrorCode = 0;
  m_slExeList = 0;
  m_slReadOutList = 0;
  m_cs = 0;
  m_Assert = fnAssertInitIniFile();
  if (m_Assert != "") {
    Application->Terminate();
    return;
  }
  //nɨtv, ~dݨLi{H
  if (fnAdjustProcessPrivilege(GetCurrentProcess(), "SeDebugPrivilege") == false) {
    m_ErrorCode = GetLastError();
    Application->Terminate();
    return;
  }

  this->Caption = fnGetExeVS();
  String iniFileName = fnGetExecuteIniFileName();
  m_slExeList = fnNewListForIniValue(iniFileName, L"ExecuteList");
  for (int i = 0; i < m_slExeList->Count; i++) {
    lb->Items->Add(m_slExeList->Names[i]);
  }
  m_slReadOutList = new TStringList();
  m_cs = new TCriticalSection();
  Timer1->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TMain::FormDestroy(TObject *Sender)
{
  if (m_Dos != NULL) {
    delete m_Dos;
  }
  if (m_Assert != "") {
    ShowMessage(m_Assert);
  }
  if (m_ErrorCode != 0) {
    ShowMessage(fnGetErrorCodeMsg(m_ErrorCode));
  }
  if (m_slExeList != NULL) {
    delete m_slExeList;
  }
  if (m_slReadOutList != NULL) {
    delete m_slReadOutList;
  }
  if (m_cs != NULL) {
    delete m_cs;
  }
}
//---------------------------------------------------------------------------
void __fastcall TMain::m_OnReadOut(TObject *Sender, String aStr)
{
  m_cs->Enter();
  m_slReadOutList->Add(aStr);
  m_cs->Leave();
}
//---------------------------------------------------------------------------
void __fastcall TMain::m_OnProcessTerminate(TObject *Sender, String aStr)
{
  m_cs->Enter();
  m_slReadOutList->Add(aStr);
  m_cs->Leave();
}
//---------------------------------------------------------------------------
void __fastcall TMain::m_OnException(TObject *Sender, String aStr)
{
  m_cs->Enter();
  m_slReadOutList->Add(aStr);
  m_cs->Leave();
}
//---------------------------------------------------------------------------
void __fastcall TMain::Button1Click(TObject *Sender)
{
  TButton *btn = Button1;
  TLabel *lab = Label1;
  TListBox *lb = ListBox1;
  TCircle *cr = Circle1;
  String ExeName, CmLine;
  int idx = lb->ItemIndex;

  if (idx > -1) {
    ExeName = lb->Items->Strings[idx];
    CmLine = m_slExeList->ValueFromIndex[idx];
    if (m_Dos == NULL) {
      m_Dos = new TDosCmd(CmLine);
      m_Dos->ReadOutEvent = m_OnReadOut;
      m_Dos->ProcessTerminateEvent = m_OnProcessTerminate;
      m_Dos->ExceptionEvent = m_OnException;
      m_Dos->Start();
      cr->Fill->Color = TAlphaColorRec::Lime;
      btn->Text =  "delete DosCmd";
      lab->Text = Format("create %s process", ARRAYOFCONST((ExeName)));
    }
    else {
      delete m_Dos;
      m_Dos = NULL;
      m_slReadOutList->Clear();
      cr->Fill->Color = TAlphaColorRec::Red;
      btn->Text = "create DosCmd";
      lab->Text = Format("delete %s process", ARRAYOFCONST((ExeName)));
    }
  }
  else {
    lab->Text = "select the item from above";
  }
}
//---------------------------------------------------------------------------
void __fastcall TMain::Button2Click(TObject *Sender)
{
  TLabel *lab = Label1;
  if (m_Dos != NULL) {
    m_Dos->AddCmd(Edit1->Text);
  }
  else {
    lab->Text = "select the item and push 'create DosCmd' button";
  }
}
//---------------------------------------------------------------------------
void __fastcall TMain::Image1Click(TObject *Sender)
{
  Memo1->Lines->Clear();
}
//---------------------------------------------------------------------------
void __fastcall TMain::Timer1Timer(TObject *Sender)
{
  TMemo *mo = Memo1;
  TLabel *lab = Label1;
  int MoCount, RoCount;
  RoCount = m_slReadOutList->Count;

  if (RoCount != 0) {
    mo->Lines->Add(m_slReadOutList->Strings[0]);
    MoCount = mo->Lines->Count;
    mo->GoToTextEnd();
    lab->Text = Format("readout(%d/%d)", ARRAYOFCONST((MoCount, MoCount + RoCount - 1)));
    m_slReadOutList->Delete(0);
  }
}
//---------------------------------------------------------------------------


